/***************************************************/
/* Last Revised:
$Id: Laser.h,v 1.1 2004/02/11 20:28:52 jminguez Exp jminguez $
*/
/***************************************************/

/* 
   Este fichero contiene todas las definiciones de datos y funciones de manipulacion 
   del laser
*/

#ifndef LaserFicher
#define LaserFichero

#include "TData.h"
#include "Matriz.h"

/* ************************************************************************ */
/* ****************** DEFINICION DEL LASER  ***** ************************* */
/* ************************************************************************ */

#define NUMPUNTOSLASER 361
//#define MAXRANGOLASER 8.1829 //6 //8.1829 //6 //8.1829
#define MAXRANGOLASER 6.0 //6 //8.1829 //6 //8.1829
/* #define MAXRANGOLASER 80 */

#define POSxSENSOR 0.16F
//#define POSxSENSOR 0.0F
#define POSySENSOR 0.0F
#define POStSENSOR 0.0F

extern Tsc PosSensorRobot; /* Posicion del sensor en el sistema del robot */
//extern float cosAng[361];
//extern float sinAng[361];
/* ************************************************************************ */
/* ****************** DEFINICION DE LAS FUNCIONES ************************* */
/* ************************************************************************ */

/* --------------------------------------------------------------------------------------- */            /* INICIALIZACION Y USO                                                                    */
/* --------------------------------------------------------------------------------------- */

/* --------------------------------------------------------------------------------------- */
/* InitLaser                                                                               */ 
/*  .... Inicializa todo lo necesario para usar el laser                                   */ 

void InitLaser();

/* --------------------------------------------------------------------------------------- */
/* ProyectaLaser2Matriz                                                                    */ 
/* .... Coje un laserazo y lo proyecta en la matriz actualizando las celdas libres y las   */
/* .... ocupadas. Esta funcion ademas tiene en cuenta que los laserazos podrian salirse    */
/* .... de la matriz para que no de seg fault.                                             */
/* .... In: La matriz, el laserazo crudo, el sistema de referencia del sensor, robot y matriz */
/* .... Out: La matriz actualizada                                                         */

void ProyectaLaser2Matriz(float a[][DIMMATRIZ],
			  Tscan *staticPt,
			  Tscan *movingPt,
			  Tscan *unknownPt,
			  Tscan *outPt,
			  Tsc *Srobot, 
			  Tsc *Smatriz);
#endif 

