---------------------------------------------------------------------
-- Fichero:   servidores_inm.ads
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.0 27-3-2002
-- Proposito: Implementacion del techo de prioridad inmediato
---------------------------------------------------------------------
-- En GNAT 3.12 para Windows NT la herencia de prioridades no funciona.
-- Este paquete implementa el techo de prioridad inmediato: antes de
-- ejecutar cada servicio se sube la prioridad
-- Nota: Por ejemplo, si los clientes tienen prioridades 15 y 16 el 
--       techo+1 debera ponerse a la siguiente prioridad de NT, es decir: 20
--       No utilizar la prioridad 31 porque no funciona en windows NT

with system;
package servidores_inm is

  s1_prioridad: System.Any_Priority:= 16; 
  procedure s1_servicio1;
  procedure s1_servicio2;

  s2_prioridad: System.Any_Priority:= 14; 
  procedure s2_servicio1;
  procedure s2_servicio2;
    
end servidores_inm;