---------------------------------------------------------------------
-- Fichero:   traza.ads
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.1 14-3-2003
-- Proposito: Paquete para obtener trazas de tareas
---------------------------------------------------------------------
-- v2.0  27-3-2002  JDT
--    Ya no es un paquete generico
--    Eliminada funcion traza_completa
--    El numero maximo de anotaciones es 1000
-- v2.1  14-3-2003  JDT
--    Anadido parametro del instante de inicio de la traza
---------------------------------------------------------------------

with Ada.Real_Time;
use  Ada.Real_Time;

package traza is

  procedure comienzo_traza(inicio: in time:= Time_First);
  -- Debe ser la primera llamada al paquete
  -- Si no se pasa el instante de inicio, se toma el instante actual
  
  procedure ejecuto(tarea: in positive);    
  -- Anota el inicio de ejecucion de una tarea
  
  procedure termino(tarea: in positive); 
  -- Anota el fin de ejecucion de una tarea
  
  procedure escribe_traza(discretizacion: duration:= 0.5);                          
  -- Escribe la traza por pantalla, con la discretizacion deseada
  -- Puede re-direccionarse a un fichero de texto desde el DOS
  -- haciendo:  nombreprograma > fichero.txt

end traza;
