---------------------------------------------------------------------
-- Fichero:   ejemplo_interrupciones.adb
-- Autor:     J.D.Tardos
-- Version:   v1.0 5-4-2002
-- Proposito: Ejemplo de uso de Generador_Interrupciones
---------------------------------------------------------------------
with MaRTE_OS;
with Simulador_Teclado, computos, servidores, traza, system, ada.real_time, text_io,Queue_Pkg;
use  Simulador_Teclado, computos, servidores, traza, ada.real_time, text_io;
procedure apartado2 is 

   package dio is new text_io.fixed_io(duration); use dio;
   Tinicio : time:= clock;
   intervalo : constant Time_Span:= milliseconds(30000) ;

   type Evento is record
	tiempo:  Time;
	caracter: Character;
   end record;

   package cola is new Queue_Pkg(Data_Item => Evento, Queue_Size => 10); use cola;
   evento_actual: Evento;

   protected Interrupt_Handler is
      entry Wait_for_Event(un_evento: out Evento);
      procedure Handler; 
   private
      Cola_eventos: cola.queue;
      Interrupt_Ocurred: boolean:=false;
   end;

   protected body Interrupt_Handler is
      procedure Handler is 
      begin
        Interrupt_Ocurred := true;
        --informacion del evento
	evento_actual.caracter:=leer_caracter;
	evento_actual.tiempo:=clock;
	Add(Cola_eventos,evento_actual);
      end;

	entry Wait_for_Event (un_evento: out Evento) when Interrupt_Ocurred is
	begin
	 Extract(Cola_eventos,un_evento);
	 if Empty (Cola_eventos) then
	   Interrupt_ocurred := false;
	 end if;
	end;
	 
   end Interrupt_Handler;

   

	procedure comun is
	t1_prioridad: constant system.any_priority:= 4;  -- poner lo adecuado
	t2_prioridad: constant system.any_priority:= 2;  -- poner lo adecuado
	t3_prioridad: constant system.any_priority:= 1;  -- poner lo adecuado
	prioridad_esporadico: constant system.any_priority:= 3;  -- poner lo adecuado
	tinicio: constant time:= clock;
	
	function max (t1,t2: time) return time is
	begin
		if t1>t2 then return t1;
		else  return t2;
		end if;
	end max;

	--NUEVA TAREA: SERVIDOR ESPORADICO
	task servidor_esporadico is pragma priority (prioridad_esporadico); end;
	task body servidor_esporadico is
		Replishment_Period: time_span := milliseconds(1250);
		Activation_Time: time;
		Next_Start: time := tinicio;
		Time_Stamp: time;
	begin
		loop
			Interrupt_Handler.Wait_for_Event(evento_actual); 
			Time_Stamp:=evento_actual.tiempo;
			--comprobamos si el tiempo en el que llega el evento es menor que 
			Activation_Time:= max(Time_Stamp, Next_Start);
			--Procesado del evento
			put("Tiempo actual: "); put (to_duration(clock-tinicio), 4, 6);
			put("     Caracter: "); put (evento_actual.caracter); new_line;
			ejecuto(8);
			computo(0.15);
			termino(8);
			--calculamos nueva activacion
			Next_Start:=Activation_time + Replishment_Period;
			delay until Next_Start;
		end loop;
	end servidor_esporadico;

	task t1 is pragma priority (t1_prioridad); end;
	task body t1 is
		periodo: constant Time_Span:= milliseconds(1000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(1);
		computo(0.1);		
		s1.servicio1;	
		termino(1);	
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	task t2 is pragma priority (t2_prioridad); end;
	task body t2 is
		periodo: constant Time_Span:= milliseconds(2000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(2);
		computo(0.50);
		s2.servicio1;
		termino(2);
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	task t3 is pragma priority (t3_prioridad); end;
	task body t3 is
		periodo: constant Time_Span:= milliseconds(4000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(3);
		s2.servicio2;
		computo(0.30);
		s1.servicio2;
		termino(3);
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	begin -- comun
	delay until(tinicio+intervalo);
	abort  t1, servidor_esporadico, t2, t3 ;
	end comun;


begin 
   Attach_Handler(Interrupt_Handler.Handler'Access);
   comienzo_traza(clock);
   comun;
   Detach_Handler;--primero aborto interrupcion
   escribe_traza(1.0);--muestro la traza

   
end;

