---------------------------------------------------------------------
-- Fichero:   ejemplo_interrupciones.adb
-- Autor:     J.D.Tardos
-- Version:   v1.0 5-4-2002
-- Proposito: Ejemplo de uso de Generador_Interrupciones
---------------------------------------------------------------------
with MaRTE_OS;
with Simulador_Teclado, ada.real_time, text_io;
use  Simulador_Teclado, ada.real_time, text_io;
procedure ejemplo_interrupciones is 

   package dio is new text_io.fixed_io(duration); use dio;
   Tinicio : time:= clock;

   protected Interrupt_Handler is
      procedure Handler; 
   end;

   protected body Interrupt_Handler is
      procedure Handler is 
        C: character;
      begin
         C := leer_caracter;
         put("Tiempo actual: "); put (to_duration(clock-Tinicio), 4, 6);
         put("     Caracter: "); put (C); new_line;
      end;
   end Interrupt_Handler;

	procedure comun is
	t1_prioridad: constant system.any_priority:= 4;  -- poner lo adecuado
	t2_prioridad: constant system.any_priority:= 2;  -- poner lo adecuado
	t3_prioridad: constant system.any_priority:= 1;  -- poner lo adecuado
	tinicio: constant time:= clock;
	
	task t1 is pragma priority (t1_prioridad); end;
	task body t1 is
		periodo: constant Time_Span:= milliseconds(1000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(1);
		computo(0.1);		
		s1.servicio1;	
		termino(1);	
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	task t2 is pragma priority (t2_prioridad); end;
	task body t2 is
		periodo: constant Time_Span:= milliseconds(2000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(2);
		computo(0.50);
		s2.servicio1;
		termino(2);
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	task t3 is pragma priority (t3_prioridad); end;
	task body t3 is
		periodo: constant Time_Span:= milliseconds(4000);
		siguiente: time:= tinicio;
	begin
		loop
		ejecuto(3);
		s2.servicio2;
		computo(0.30);
		s1.servicio2;
		termino(3);
		siguiente:= siguiente + periodo;
		delay until siguiente;
		end loop;
	end;
	
	begin -- comun
	delay until(tinicio+intervalo);
	abort t1, t2, t3;
	end comun;


begin 
   Attach_Handler(Interrupt_Handler.Handler'Access);
   comienzo_traza(clock);
   comun;
   escribe_traza(1.0);
   Detach_Handler;
end;

