---------------------------------------------------------------------
-- Fichero:   simulador_teclado.ads
-- Autor:     J.L.Villarroel, C.Sagues, J.D.Tardos
-- Version:   v2.0 4-4-2002
-- Proposito: Generar pseudo-interrupciones de teclado
---------------------------------------------------------------------
-- v2.0  4-4-2002  JDT
--    Creado a partir de Eventos Aperiodicos y mensaje
---------------------------------------------------------------------

package Simulador_Teclado is

   procedure Attach_Handler (New_Handler: access protected procedure);
   -- Conecta las interrupciones de teclado simuladas con el
   -- manejador New_Handler e inicia la simulacion del teclado.
   -- Cada vez que se simule una pulsacion de tecla, se llamara
   -- al manejador. La tecla habra que leerla con leer_tecla

   procedure Detach_Handler;
   -- Desconecta el manejador y termina la simulacion de teclado

   function leer_caracter return Character;
   -- Lee el ultimo caracter recibido.
   -- Si no se lee a tiempo, se pierde

end Simulador_Teclado;
