------------------------------------------------------------------------------
-- --------------------        M a R T E   O S          ------------------- --
------------------------------------------------------------------------------
--                                                             V1.59B   070502
--
--                      'l a s e r _ i m p o r t'
--
--                                   Spec
--
--
--  File 'laser_import.ads'                               By F.J.Feijoo
--                                             University of Zaragoza (UNIZAR)
--
--
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------
with MaRTE_OS; use MaRTE_OS;
with Drivers_MaRTE;  use Drivers_MaRTE;
with System, Ada.Unchecked_Conversion;
with Ring_Buffers;
with Interfaces.C;

package laser_import is

package C renames Interfaces.C;
          use type C.char_array;


	MAXNDATA: constant Interfaces.C.Size_t := 801; -- (de 0 a 801)
	MAXVALORES: constant Interfaces.C.Size_t := 400; -- (de 0 a 401)
	--velocidades posibles de conexion
	BAUD_500000 : constant Integer := 512;
	BAUD_38400 : constant Integer := 256;
	BAUD_19200 : constant Integer := 128;
	BAUD_9600 : constant Integer := 64;
	--modos del laser
	RANGE_100 : constant Integer := 32;
	RANGE_180 : constant Integer := 16;
	--resolucion del laser
	RES_1_DEG : constant Integer := 8;
	RES_0_5_DEG : constant Integer := 4;
	RES_0_25_DEG : constant Integer := 2;
	-- en mm o en cm
	MMMODE : constant Integer := 1;
	CMMODE : constant Integer := 0;


	procedure showdata(len: C.Int; buf: C.char_array);
	pragma Import (C, showdata, "showdata");
	
	procedure showLaser(len: C.Int; buf: C.char_array);
	pragma Import (C, showLaser, "showLaser");
	
	procedure chkstatus(chk: C.char);
	pragma Import (C, chkstatus, "chkstatus");
	
	procedure resetLMS;
	pragma Import (C, resetLMS, "resetLMS");
	
	procedure stopLMS;
	pragma Import (C, stopLMS, "stopLMS");
	
	procedure connectToLMS(range_mode, res_mode, unit_mode: C.Int;
				port: C.char_array; baud_sel:C.Int);
	pragma Import (C, connectToLMS, "connectToLMS");
	
	function readLMSdata(buf: C.char_array) return C.Int;
	pragma Import (C, readLMSdata, "readLMSdata");


	function GetCountLaser return C.Int;
	pragma Import (C, GetCountLaser, "GetCountLaser");
	
	function GetScanResLaser return C.Double;
	pragma Import (C, GetScanResLaser, "GetScanResLaser");
	
	function GetRangeResLaser return C.Double;
	pragma Import (C, GetRangeResLaser, "GetRangeResLaser");


	function readLMSValues return C.Int;
	pragma Import (C, readLMSValues, "readLMSValues");

	function readLMSValuesDemand return C.Int;
	pragma Import (C, readLMSValuesDemand, "readLMSValuesDemand");

	function laserazo (i: C.Int) return C.Int;
	pragma Import (C, laserazo, "laserazo");

	procedure lockLaser;
	pragma Import (C, lockLaser, "lockLaser");

	procedure unlockLaser;
	pragma Import (C, unlockLaser, "unlockLaser");

	function getStatus return C.Int;
	pragma Import (C, getStatus, "getStatus");

	procedure vaciarLaser;
	pragma Import (C, vaciarLaser, "vaciarLaser");


end laser_import;