#include <stdio.h>
#include <sys/pci.h>
#include "yenta_socket.h"
#include "rt61-interface.h"

#define RT2561_VENDOR   0x1814
#define RT2561_DEVICE   0x0302

// #define PCI_VENDOR_ID_RICOH             0x104C
 #define PCI_DEVICE_ID_TI_AC56    0xAC56



// #define PCI_VENDOR_ID_RICOH             0x1180
// #define PCI_DEVICE_ID_RICOH_RL5C475     0x0475

// #define PCIBRIDGE_VENDOR 0x1106
// #define PCIBRIDGE_DEVICE 0x8305
// #define PCIBRIDGE_VENDOR 0x8086
// #define PCIBRIDGE_DEVICE 0x7190 //0

// --------------------------------------------
//  2) SIMPLE FUNCTIONS
// --------------------------------------------
static void pause(){
   char key;
   printf(" press Enter...");
   key = getchar();
}
// -----------------------------------------------------------------------
static void msg(char *s){
    printf(s);
    pause();
}

void show_pci_config_space(unsigned int bus, unsigned int device_fn);

static void pci_setup_bridge(struct pci_device *bridge)
{
    struct pci_bus_region region;
    u32 l, io_upper16;

    printf("pci_setup_bridge\n");

    /* Set up the top and bottom of the PCI I/O segment for this bus. */
/*    pcibios_resource_to_bus(bridge, &region, bus->resource[0]);*/
    region.start = 0xC000;
    region.end = 0xCFFF;
/*    if (bus->resource[0]->flags & IORESOURCE_IO) {*/
        pci_read_config_dword(bridge, PCI_IO_BASE, &l);
        l &= 0xffff0000;
        l |= (region.start >> 8) & 0x00f0;
        l |= region.end & 0xf000;
        /* Set up upper 16 bits of I/O base/limit. */
        io_upper16 = (region.end & 0xffff0000) | (region.start >> 16);
        printf( "  IO window: %04lx-%04lx\n",
            region.start, region.end);
//     }
//     else {
//         /* Clear upper 16 bits of I/O base/limit. */
//         io_upper16 = 0;
//         l = 0x00f0;
//         printf( "  IO window: disabled.\n");
//     }
    /* Temporarily disable the I/O range before updating PCI_IO_BASE. */
    pci_write_config_dword(bridge, PCI_IO_BASE_UPPER16, 0x0000ffff);
    /* Update lower 16 bits of I/O base/limit. */
    pci_write_config_dword(bridge, PCI_IO_BASE, l);
    /* Update upper 16 bits of I/O base/limit. */
    pci_write_config_dword(bridge, PCI_IO_BASE_UPPER16, io_upper16);

    /* Set up the top and bottom of the PCI Memory segment
    for this bus. */
/*    pcibios_resource_to_bus(bridge, &region, bus->resource[1]);*/
    region.start = 0xD4000000;
    region.end = 0xD5FFFFFF;
/*    if (bus->resource[1]->flags & IORESOURCE_MEM) {*/
        l = (region.start >> 16) & 0xfff0;
        l |= region.end & 0xfff00000;
        printf("  MEM window: %08lx-%08lx\n",
            region.start, region.end);
//     }
//     else {
//         l = 0x0000fff0;
//         printf( "  MEM window: disabled.\n");
//     }
    pci_write_config_dword(bridge, PCI_MEMORY_BASE, l);

    /* Clear out the upper 32 bits of PREF limit.
    If PCI_PREF_BASE_UPPER32 was non-zero, this temporarily
    disables PREF range, which is ok. */
    pci_write_config_dword(bridge, PCI_PREF_LIMIT_UPPER32, 0);

    /* Set up PREF base/limit. */
/*    pcibios_resource_to_bus(bridge, &region, bus->resource[2]);*/
    region.start = 0xD7000000;
    region.end = 0; // 0xD8FFFFFF;
/*    if (bus->resource[2]->flags & IORESOURCE_PREFETCH) {*/
        l = (region.start >> 16) & 0xfff0;
        l |= region.end & 0xfff00000;
        printf( "  PREFETCH window: %08lx-%08lx\n",
            region.start, region.end);
//     }
//     else {
//         l = 0x0000fff0;
//         printf( "  PREFETCH window: disabled.\n");
//     }
    pci_write_config_dword(bridge, PCI_PREF_MEMORY_BASE, l);

    /* Clear out the upper 32 bits of PREF base. */
    pci_write_config_dword(bridge, PCI_PREF_BASE_UPPER32, 0);

/*    pci_write_config_word(bridge, PCI_BRIDGE_CONTROL, 0);*/
}


int main()
{
    static struct pci_device dev, *dev_p, *pci_bridge_dev;
    struct pci_device_id id;
    uint8_t byte;
    uint32_t dword;

//     // 6.- Look for the cardbus card
//     if (pci_find_device(PCIBRIDGE_VENDOR, PCIBRIDGE_DEVICE, NULL, pci_bridge_dev)) {
//         printf("PCIBRIDGE not found\n");
//         return -1;
//     }
//     printf("PCIBRIDGE found\n");
// 
//     pci_write_config_dword(pci_bridge_dev, PCI_PRIMARY_BUS,
//                   (0 << 24) |              /* sec. latency timer */
//                   (1 << 16) | /* subordinate bus */
//                   (1 << 8) |  /* secondary bus */
//                    0);        /* primary bus */
// 
//     pci_read_config_byte(pci_bridge_dev, PCI_CB_PRIMARY_BUS, &byte);
//     printf("PCIBRIDGE primary bus: %u\n", byte);
//     pci_read_config_byte(pci_bridge_dev, PCI_CB_CARD_BUS, &byte);
//     printf("PCIBRIDGE card bus: %u\n", byte);
//     pci_read_config_byte(pci_bridge_dev, PCI_CB_SUBORDINATE_BUS, &byte);
//     printf("PCIBRIDGE subordinate bus: %u\n", byte);
//     printf("PCIBRIDGE IRQ: %d\n",pci_bridge_dev->irq);
// 
//     pci_setup_bridge(pci_bridge_dev);
// 
//     adjust_pci_device(pci_bridge_dev);
//     printf("PCIBRIDGE Adjusted!\n");
// 
//     printf("config space of PCI BRIDGE\n");
//   //  show_pci_config_space(pci_bridge_dev->bus, pci_bridge_dev->devfn);
//     pause();

    // 1.- FIND the cardbus bridge
    dev_p = &dev;
    if (pci_find_device(PCI_VENDOR_ID_TI, PCI_DEVICE_ID_TI_AC56, NULL, dev_p)) {
        printf("BRIDGE not found\n");
        return -1;
    }
    printf("BRIDGE found\n");

//     printf("devfn %c bus %c class %c vendor %c dev_id %c irq %c pin %c \n",dev_p->devfn,dev_p->bus,dev_p->class,dev_p->vendor,dev_p->dev_id,dev_p->irq,dev_p->pin);



    // 2.- Set it as bus master and adjust latency
    adjust_pci_device(dev_p);
    printf("BRIDGE Adjusted!\n");

    // 3.- Assign BUS numbers
    dev_p->primary = 0;        /* number of primary bridge */
    dev_p->secondary = 2;      /* number of secondary bridge */
    dev_p->subordinate = 5;     /* max number of subordinate buses */

    // 4.- Read its base address
    pci_read_config_dword(dev_p, PCI_BASE_ADDRESS_0, &dword);
    printf("BRIDGE read base address: %X (find device: %X, linux:0xD7821000)\n", dword, dev_p->membase);
//     dev_p->membase = dword;
    dev_p->membase = 0x24000000;
    //pause();
    // 5.- Install YENTA driver, activating the socket!
    if (yenta_probe (dev_p, &id)) {
        printf("ERROR en yenta_probe\n");
        return -1;
    }
    printf("YENTA activated\n");

    pci_read_config_byte(dev_p, PCI_CB_PRIMARY_BUS, &byte);
    printf("BRIDGE primary bus: %u\n", byte);
    pci_read_config_byte(dev_p, PCI_CB_CARD_BUS, &byte);
    printf("BRIDGE card bus: %u\n", byte);
    pci_read_config_byte(dev_p, PCI_CB_SUBORDINATE_BUS, &byte);
    printf("BRIDGE subordinate bus: %u\n", byte);
    printf("BRIDGE IRQ: %d\n",dev_p->irq);

    printf("config space of CARDBUS\n");
    show_pci_config_space(dev_p->bus, dev_p->devfn);
    pause();

     // 7.- Configure ralink memory, irq
//     pcibios_write_config_dword(2, 0, PCI_BASE_ADDRESS_0, 0x14000000);
    pcibios_write_config_dword(2, 0, PCI_BASE_ADDRESS_0, 0x22000000);
    pcibios_read_config_dword(2, 0, PCI_BASE_ADDRESS_0, &dword);
    pcibios_write_config_byte(2, 0, PCI_INTERRUPT_LINE, dev_p->irq);
    pcibios_read_config_byte(2, 0, PCI_INTERRUPT_LINE, &byte);
    pcibios_write_config_dword(2, 0, PCI_COMMAND, 0x04100012);
    pcibios_write_config_dword(2, 0, PCI_CACHE_LINE_SIZE, 0x00004010);


    printf("config space of RALINK\n");
    show_pci_config_space(2, 0);
    pause();

//     // 8.- Execute a test
//     msg ("PROMISC TEST for RT61 Module");
// 
//     if (rt61_init (1, 27))
//         return -1;
// 
//     while (1) {
//         msg ("Enable promisc mode");
//         rt61pci_enable_promisc ();
//         msg ("Disable promisc mode");
//         rt61pci_disable_promisc ();
//     }




  wifi_frame_t frame;
   int i;
   unsigned char buff [MAX_DATA_SIZE];
   mac_address addr;
   mac_address mac_dest = {0x00, 0x80, 0x5A, 0x39, 0x88, 0xAE};
   int read_bytes;

   msg ("ACK TEST for RT61 Module (CHECK IF I RECEIVE an ACK)");

   if (rt61_init (5, 27))
      return -1;
	

// struct timespec abs_timeout;
// 	abs_timeout.tv_nsec = 1*1000*1000*1000;
// 	abs_timeout.tv_sec = 0;

pause();

   msg ("tarjeta iniciada");   
   while (1) {
//    	msg ("comienza el bucle");   
      if (!rt61pci_recv (&frame, NULL)) {
         rt61pci_frame_getSourceMac (&frame, addr);
         read_bytes = rt61pci_frame_getData (&frame, buff, MAX_DATA_SIZE);
         printf ("RECEIVED DATA: ");
         for (i=0; i<read_bytes; i++)
            printf ("%.2X ", buff [i]);
         printf ("  FROM: ");
         for (i=0; i<6; i++)
            printf ("%.2X ", addr [i]);
         printf ("\n");

      	if (rt61pci_send (buff, 5, mac_dest) < 0)
         	return -1;
	else printf("ENVIO\n");
      }
//       printf("no recibo nada\n");
      sleep (4); // in this time received packets are enqueued
   }

    return 0;
}
