pragma locking_policy (ceiling_locking) ;
pragma task_dispatching_policy (fifo_within_priorities) ;

with MaRTE_OS;
with system;
with text_io, Ada.Real_Time;
use  text_io, Ada.Real_Time;
with p2os_import; use p2os_import;

procedure ejemplo is

  package DIO is new FIXED_IO (duration) ; use DIO ;

  prioridad_actualizacion: constant System.Any_Priority := 22;
  prioridad_movimiento	 : constant System.Any_Priority := 19;

procedure principal is

task actualiza_p2os is
     pragma Priority (prioridad_actualizacion);
end  actualiza_p2os;
task movimiento is
   pragma Priority (prioridad_movimiento);
end movimiento;

task body actualiza_p2os is
  periodo   	: constant Time_Span := Milliseconds (100);
  siguiente 	: Time;
  port		: C.char_array := "/dev/ttyS0";  
  var		: C.Int;
begin
  --Comienza la incialización del microcontrolador
  var:=initP2os(port);
  while true loop
	--Con esta función se actualiza el objeto protegido
     	p2osGetValues;
	--La tarea se suspende hasta que vuelva a empezar su periodo
	siguiente := siguiente + periodo;
        delay until siguiente;
  end loop;
end actualiza_p2os;




task body movimiento is
         periodo   : constant Time_Span := Milliseconds (200);
         siguiente : Time;
	 x: float := 0.0;

begin
   siguiente := clock;
   while true loop

	--Obtenemos el valor de X
	lockP2os;
	    x := float(p2osGetXpos);
	unlockP2os;

	--Ordenamos al micro que mueva los motores a 0.2 m/s
	if x < 3.0 then SetSpeed(0.2,0.0);			
	else	SetSpeed(0.0,0.0);
	end if;
	
	--La tarea se suspende hasta que vuelva a empezar su periodo
	siguiente := siguiente + periodo;
        delay until siguiente;
   end loop;

   --Fin de control de movimiento

end movimiento;

   begin

       while true loop
	null;
       end loop;
	
end principal;


begin

--Lanzo principal
principal;
--Se sale del programa

end ejemplo;
