/***************************************************/
/* Last Revised: 
$Id: Bresenham.h,v 1.1 2004/02/11 20:29:39 jminguez Exp jminguez $
*/
/***************************************************/

/*
  Este fichero implementa el algoritmo de Bresenham.
*/

#ifndef BRESE
#define BRESE

#define SPT 1
#define MPT 2
#define UPT 3

#include "Matriz.h"

/* ----------------------------------------------------------------------------- */
/* LineBresenham                                                                 */
/* ... proyecta una linea en la matriz actualizando todas las celdas por las que */
/* ... pasa como VACIAS.                                                         */
/* ... In: las coordenadas de las celdas inicial y final                         */
/* ... Out: la salida es la matriz actualizada                                   */
/* ... Nota: es tu responsabilidad comprobar que los puntos estan dentro de la   */
/* ... si no es seguro que dara un segmentation fault                            */

void LineBresenham(int x1,int y1,int x2,int y2,
		   float a[][DIMMATRIZ], short tag);

int RayTracing(int x1,int y1,int x2,int y2,
		   float a[][DIMMATRIZ], int *xout, int *yout);

#endif 
