
/*****************************************************************************/
/*                                                                           */
/*  Fichero:     laser.c                                                     */
/*  Autor:       Javier C. Osuna Sanz                                        */
/*  Creado:      17/10/2002                                                  */
/*  Modificado:  08/07/2003                                                  */
/*                                                                           */
/*****************************************************************************/

// Es necesario incluir "windows.h" para que el tipo "DWORD", utilizado en
// "sick_command.h", est� definido.
// La inclusi�n puede sustituirse por:
//
// typedef unsigned long       DWORD;

#include <stdio.h>
//#include <windows.h>

#include "laserInt.h"


#ifdef  __cplusplus
extern "C" {
#endif

//#include "sick_command.h"

#ifdef  __cplusplus
}
#endif


// ----------------------------------------------------------------------------
// TIPOS.
// ----------------------------------------------------------------------------

typedef struct {
  TCoordenadas p1C0;
  TCoordenadas p2C0;

  TCoordenadasPolares p1P2;
  TCoordenadasPolares p2P2;
} TSegmento;

#define MAX_SEGMENTOS 200

typedef struct {
  int longitud;
  TSegmento segmento[MAX_SEGMENTOS];
} TEntorno;

// ----------------------------------------------------------------------------
// VARIABLES.
// ----------------------------------------------------------------------------

// TSR SR_NINGUNO={0.0F,0.0F,0.0F};
TSR SR_NINGUNO;
// SR_NINGUNO.posicion={0.0F,0.0F};
// SR_NINGUNO.orientacion={0.0F};
static TTipoLaser tipo_laser=LASER_NINGUNO;

static TSR SR2interno; // Utilizado para simular el l�ser.

static TEntorno entorno_sim; // Utilizado para simular el l�ser.

// ----------------------------------------------------------------------------
// FUNCIONES.
// ----------------------------------------------------------------------------

static int InicializarLaserSimulado(TSR *SR2);
static void LeerBarridoSimulado(TSR *SR1,TInfoLaser *barrido);

static int InicializarLaserReal();
static void LeerBarridoReal(TInfoLaser *barrido);
static int FinalizarLaserReal();

int InicializarLaser(TTipoLaser tipo,TSR SR2) {
//   if (tipo_laser!=LASER_NINGUNO)
//     return 0;
// 
//   switch (tipo) {
//     case LASER_SIMULADO:
//       if (!InicializarLaserSimulado(&SR2))
//         return 0;
//       break;
// 
//     case LASER_REAL:
  InicializarLaserReal();
//         return 0;
//       break;
// 
//     default:
//       return 0;
//   }

//   tipo_laser=tipo;
  return 1;
}

void LeerBarrido(TSR SR1,TInfoLaser *barrido) {
//   switch (tipo_laser) {
//     case LASER_SIMULADO:
//       LeerBarridoSimulado(&SR1,barrido);
//       break;
// 
//     case LASER_REAL:
      LeerBarridoReal(barrido);
//       break;
// 
//     default:
//       break;
//   }
}

int FinalizarLaser() {
//   switch (tipo_laser) {
//     case LASER_SIMULADO:
//       break;
// 
//     case LASER_REAL:
     /* if (!*/
FinalizarLaserReal();
//         return 0;
//       break;
// 
//     default:
//       return 0;
//   }
// 
//   tipo_laser=LASER_NINGUNO;
  return 1;
}

// L�SER SIMULADO

static int InicializarLaserSimulado(TSR *SR2) {
  FILE *fp;
  int i;

  SR2interno=(*SR2);
  fp=fopen("entorno.nssr","r");
  if (!fp) {
    entorno_sim.longitud=0;
    return 0;
  }

  fscanf(fp,"%d",&(entorno_sim.longitud));

  for (i=0; i<entorno_sim.longitud; i++) 
    fscanf(fp,"%f %f %f %f",&(entorno_sim.segmento[i].p1C0.x),&(entorno_sim.segmento[i].p1C0.y),&(entorno_sim.segmento[i].p2C0.x),&(entorno_sim.segmento[i].p2C0.y));

  fclose(fp);

  return 1;
}

static void LeerBarridoSimulado(TSR *SR1,TInfoLaser *barrido) {

  // Amplitud del barrido (en grados).
  #define AMPLITUD_BARRIDO 180

  // Longitud del barrido (en puntos).
  #define PUNTOS_BARRIDO 361

  TSegmento *segmento;
  TCoordenadas p;
  float angulo;
  int i,j;

  barrido->angulo_inicial=(2.0F*PI/360.0F)*(-(float)AMPLITUD_BARRIDO/2.0F);
  barrido->incremento_angulo=(2.0F*PI/360.0F)*((float)AMPLITUD_BARRIDO/(float)(PUNTOS_BARRIDO-1));
  barrido->longitud=PUNTOS_BARRIDO;

  for (i=0; i<entorno_sim.longitud; i++) {
    segmento=&(entorno_sim.segmento[i]);

    p=segmento->p1C0;
    TRANSFORMACION02(SR1,&SR2interno,&p)
    ConstruirCoordenadasPC(&(segmento->p1P2),p);

    p=segmento->p2C0;
    TRANSFORMACION02(SR1,&SR2interno,&p)
    ConstruirCoordenadasPC(&(segmento->p2P2),p);
  }

  for (i=0; i<barrido->longitud; i++) {
    angulo=barrido->angulo_inicial+i*barrido->incremento_angulo;
    barrido->distancia[i]=ALCANCE_LASER;
    for (j=0; j<entorno_sim.longitud; j++)
      MinimaDistanciaCuadradoCorte(entorno_sim.segmento[j].p1P2,entorno_sim.segmento[j].p2P2,angulo,&(barrido->distancia[i]));
  }

  #undef AMPLITUD_BARRIDO
  #undef PUNTOS_BARRIDO
}

// L�SER REAL

static int InicializarLaserReal() {
/*  if (!initialize())
    return 0;

  if (!installation_mode())
    return 0;

  if (!change_baud_rate_sick(CBR_38400))
    return 0;

  if (!configure_scan(180.0F,0.5F))
    return 0;

  if (!laser_units(mm))
    return 0;

  configure_scan_mode(ALL_VALUES);

  if (!laser_enter_continuous_mode())
    return 0;
*/

  return 1;
}

static void LeerBarridoReal(TInfoLaser *barrido) {
//  float divisor;
  int i;
/*
  read_one_scan(&barrido_sick); // Siempre devuelve 1 (correcto).

  barrido->angulo_inicial=(PI/180.0F)*(float)barrido_sick.start_angle-PI/2.0F;
  barrido->incremento_angulo=(PI/180.0F)*barrido_sick.angular_step;
  barrido->longitud=barrido_sick.N;
*/
//   barrido->angulo_inicial= laser->GetMinAngle();
//   barrido->incremento_angulo = laser->GetScanRes(); 
//   barrido->longitud = laser->GetCount();

// NO ESTOY NADA SEGURO DE ESTO!!!! min_angle == 0???


//   barrido->incremento_angulo = GetScanResLaser(); 
//   barrido->longitud = GetCountLaser();


//   printf("ai %f ia %f long %d\n",barrido->angulo_inicial,barrido->incremento_angulo,barrido->longitud );

/*
  switch (barrido_sick.data_units) {
    case mm:
      divisor=1000.0F;
      break;
    case cm:
      divisor=100.0F;
    default: // dm
      divisor=10.0F;
  }
  for (i=0; i<barrido->longitud; i++)
    barrido->distancia[i]=barrido_sick.data[i]/divisor;
*/int min=1000000;
lockLaser();  
  barrido->angulo_inicial= -PI/2;
  barrido->incremento_angulo = (0.5 /180) * PI; 
  barrido->longitud = GetCountLaser();

for (i=0; i<barrido->longitud; i++){
    float b = (float)laserazo(i);
    b = b / 1000.0; 
    barrido->distancia[i] = b; 
    if (laserazo(i)<min) min=laserazo(i);
}
    unlockLaser();
//     printf("pri %f ult %f \n",barrido->distancia[0],barrido->distancia[360]);
  //  printf("Numlaser:%d,min:%d\n",	barrido->longitud,min);
//     barrido->distancia[i] = laserazo(i);
	
}

static int FinalizarLaserReal() {
  /*if (!installation_mode())
    return 0;

  if (!change_baud_rate_sick(CBR_9600))
    return 0;

  return initialize();*/
  return 1;
}



