
/*****************************************************************************/
/*                                                                           */
/*  Fichero:     nd.h                                                        */
/*  Autor:       Javier C. Osuna Sanz                                        */
/*  Creado:      17/10/2002                                                  */
/*                                                                           */
/*****************************************************************************/

#ifndef nd_h
#define nd_h

/* #include "geometria.h" */

// ----------------------------------------------------------------------------
// TIPOS.
// ----------------------------------------------------------------------------

typedef struct {
  float x;
  float y;
} TCoordenadas;

typedef struct {
  TCoordenadas posicion;
  float orientacion;
} TSR; // Sistema de referencia.

// Coordenadas cartesianas. Espacio real (y pantalla).




// ----------------------------------------------------------------------------
// TIPOS.
// ----------------------------------------------------------------------------

typedef struct {

  // Distancias desde SR1 a la parte delantera, la parte trasera y el lado
  // izquierdo del robot, respectivamente (consideramos el robot simtrico
  // respecto del eje X).

  short int geometriaRect; // Si es cuadrado o no

  float R; // radio del robot por si es circular

  short int holonomo;

  float delante,detras,izquierda;
  float laser; // Compatibilidad josuna.

  // Distancias de seguridad mxima (frontal) y mnima (dorsal) del robot e
  // incremento a aplicar a las dimensiones del robot para obtener el robot
  // engordado.
  float dsmax,dsmin,engorde;

  // Velocidades lineal y angular mximas del robot.
  float vlmax,vamax;

  // Aceleraciones lineal y angular mximas del robot.
  float almax,aamax;

  // Mnimo espacio por el que consideramos que cabe el robot.
  float discontinuidad;

  // Perodo.
  float T;

} TParametrosND;

// Velocidades del robot.

typedef struct {
  float v;
  float w;
} TVelocidades;

typedef struct {
  TSR SR1;
  TSR SR2;
  TVelocidades velocidades;
} TInfoMovimiento;

#define MAX_PUNTOS_ENTORNO 1440

typedef struct {
  int longitud;
  TCoordenadas punto[MAX_PUNTOS_ENTORNO];
} TInfoEntorno;

// ----------------------------------------------------------------------------
// FUNCIONES.
// ----------------------------------------------------------------------------

void InicializarND(TParametrosND *parametros);

extern TVelocidades *IterarND(TCoordenadas objetivo,TInfoMovimiento *movimiento,
    TInfoEntorno *mapa,void *informacion);
  // Devuelve 0 (NULL) para indicar que hay que parar.
// si no tienes acceso a nh2.h informacion = NULL
#endif 
