/* Copyright (C) 1994, 1995, 1996, 1999 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

#ifndef _SYS_TIMEB_H
#define _SYS_TIMEB_H	1

// #include <sys/features.h>

#define __need_time_t
#include <time.h>


// // __BEGIN_DECLS

/* Structure returned by the `ftime' function.  */

struct timeb
  {
    time_t time;		/* Seconds since epoch, as from `time'.  */
    unsigned short int millitm;	/* Additional milliseconds.  */
    short int timezone;		/* Minutes west of GMT.  */
    short int dstflag;		/* Nonzero if Daylight Savings Time used.  */
  }timeb;

/* Fill in TIMEBUF with information about the current time.  */

int ftime (struct timeb *tb){
// 	struct timespec ts;
	struct timeval tv;

// 	time(&tb->time) ;
// 	clock_gettime(TIMER_ABSTIME , &ts);
//    
// 	tb->time = ts.tv_sec;
//         tb->millitm=ts.tv_nsec * 1000 * 1000;
	
	gettimeofday(&tv,NULL);
	tb->time=tv.tv_sec;
	tb->millitm = tv.tv_usec / 1000;
	
//  	printf("seconds = %d, milliseconds = %d\n",tb->time,tb->millitm);
	return 0;

}


// __END_DECLS

#endif	/* sys/timeb.h */
