#ifndef FRAMES_H_
#define FRAMES_H_
/* STATES TYPES */

#define DISCOVER 1
#define TOKEN 2
#define AUTHORIZATION 3
#define MESSAGE 4
#define DROP_TOKEN	5

typedef struct  {
  char rssi;
  char noise;
  unsigned long serial;
  char type;
  char from;
  char to;
  char retries;
  unsigned short bc_len;
} Token_Hdr ;

typedef struct  {
  char maxPri;
  char idMaxPri;
  unsigned short age;
  char acknow;   //warning: new
  char protocol; // define which type of protocol is carried by the token
  //unsigned short len;
} Token ;

typedef struct {
  unsigned short len;
  long age;
  char port;
  char priority;
  char src;
  char dest;
  char data;
}Message;


typedef struct {
  char src;
  char dest;
} Authorization ;

typedef struct {
	Token_Hdr hdr;
	union {
		 Token tkn;
		 Message msg;
		 Authorization aut;
	};
} wmpFrame;

#endif /*FRAMES_H_*/
