/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *                       'w m p _ i n t e r f a c e _ c'
 *
 *                                      
 *
 *  File 'RT-WMP.c'                     				by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with RT-WMP;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/
 
#ifndef WMPINTERFACE__H
#define WMPINTERFACE__H
#include <stdio.h> 
#include "Msg.h"


/* Queues*/
int wmpPushUCMsg(Msg *p);
int wmpPopUCMsg(Msg *p);
void wmpUCPush(char * data, unsigned short len, char dest, char priority);
void wmpUCPop(char nqueue, char * data, unsigned short* len, char* source, char* priority, char* protocol);

char wmpGetNodeId();
char wmpGetNumOfNodes();
int  wmpGetLatestLQM(char * lqm);
/* USER */
int wmpGetNumOfFreePositionsInTXUCQueue();
int wmpGetNumOfElementInTXUCQueue();
int wmpGetNumOfElementInRXUCQueue();
/* Called when node is launched */
void wmpPluginStart();

/* Call it to start the network actuation */
void wmpNetStart();

/* Call it to use the GUI of rt-wmp */
void wfprintf(FILE* f, const char *format, ...);

/* Call it to start the protocol thread N.B. Does not return*/
void wmpRun(char node_id,char active_nodes, int GUI);

/* To call to terminate the process */
int wmpExit();

#endif 
