/*------------------------------------------------------------------------
 *---------------------           RT-WMP     		  --------------------
 *------------------------------------------------------------------------
 *                                                         V3.0B  25/07/07
 *
 *          'w m p _ p r o t e c t e d _ i n t e r f a c e _ h'
 *
 *                                      
 *
 *  File 'wmp_protected_interface.h'       				by Danilo Tardioli
 *
 *  ----------------------------------------------------------------------
 *  Copyright (C) 2000-2007, Universidad de Zaragoza, SPAIN
 *
 *  Contact Addresses: Danilo Tardioli	        		 dantard@unizar.es
 *
 *  RT-WMP is free software; you can  redistribute it and/or  modify it
 *  under the terms of the GNU General Public License  as published by the
 *  Free Software Foundation;  either  version 2, or (at  your option) any
 *  later version.
 *
 *  RT-WMP  is distributed  in the  hope  that  it will be   useful, but
 *  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
 *  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
 *  General Public License for more details.
 *
 *  You should have received  a  copy of  the  GNU General Public  License
 *  distributed with RT-WMP;  see file COPYING.   If not,  write to the
 *  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
 *  02111-1307, USA.
 *
 *  As a  special exception, if you  link this  unit  with other  files to
 *  produce an   executable,   this unit  does  not  by  itself cause  the
 *  resulting executable to be covered by the  GNU General Public License.
 *  This exception does  not however invalidate  any other reasons why the
 *  executable file might be covered by the GNU Public License.
 *
 *---------------------------------------------------------------------------*/
 
#ifndef WMP_PROTECTED_INTERFACE_H_
#define WMP_PROTECTED_INTERFACE_H_
#include "core/include/global.h"
/* Low Level Communication */
int initLowLevelCom();
void closeLowLevelCom();
int llsend(char * f,int size);
int llreceive(char *f,int timeout);


/* Status setup */ 
int wmpReadConfiguration(Status * status);

/* Exit */
int wmpExit();

/* GUI Management */
#define TOPLEFT  0
#define TOPRIGHT 1
#define BOTTOM 	 2
#define MIDLEFT  3
#define MIDRIGHT 4
#define LQM 	 5
#define TTY		 6

void initGUI(int mode,int numNodes);
int wmprintf(int win,const char *format, ...); 
void exitGUI();
void dbgprintf(unsigned char level,const char *format, ...);

#define CANT_ARRIVE					0


#endif /*WMPPROTECTEDINTERFACE_H_*/
