#include "bc_queues.h"
Queue_t rxBCQueue;
Queue_t txBCQueue;


void init_bc_Queues(){	
	fprintf(stderr,"init BC queues\n");		
	initQueue(&rxBCQueue,50,LIFO,REPLACE,"rxbc");
	initQueue(&txBCQueue,50,LIFO,REPLACE,"txbc");
}

void free_bc_Queues(){	
	fprintf(stderr,"close BC queues\n");
	freeQueue(&rxBCQueue);
	freeQueue(&txBCQueue);
}



void pushRcvdBCMsg(Msg * p){
	//fprintf(stderr,"Pusho received (BC): %s \n",p->data);
	pushMsg(&rxBCQueue,p);
}

void popBCMsgToSend(Msg * p){
	popMsg(&txBCQueue,p);
	//fprintf(stderr,"bc_queues.c : Poppo to send (BC): %s \n",p->data);
}

/* GETNUMELEMENTS FUNCTIONS*/

int getNumOfElementInRXBCQueue(){
		return getNumOfElemInQueue(&rxBCQueue);
}

int getNumOfFreePositionsInTXBCQueue(){
	return getFreePositions(&txBCQueue);
}

int getNumOfElementInTXBCQueue(){
	return getNumOfElemInQueue(&txBCQueue);
}

int getHighestPriorityInTxBCQueue(){
	return getHighestPriority(&txBCQueue);
}



int getHighestPriorityAgeInTxBCQueue(){
	return getHighestPrioritysAge(&txBCQueue);
}


/* USER */

int wmpGetNumOfFreePositionsInTXBCQueue(){
	return getNumOfFreePositionsInTXBCQueue();
}


int wmpGetNumOfElementInTXBCQueue(){ //EXPORTED FUNCTION
	return  getNumOfElementInTXBCQueue();
}

int wmpGetNumOfElementInRXBCQueue(){ //EXPORTED FUNCTION
	return  getNumOfElementInRXBCQueue();
}



/* PUSH & POP FUNCTIONS*/

void PushBCMsgToSend(Msg *p){
	pushMsg(&txBCQueue,p);
}

int wmpPushBCMsg(Msg *p){
	//fprintf(stderr,"Pusho msg to transmit (BC): %s \n",p->data);
	pushMsg(&txBCQueue,p);
	fprintf(stderr,"Pusho bc, dest:%d\n",p->dest);
	return 1;
}
int wmpPopBCMsg(Msg *p){
	popMsg(&rxBCQueue,p);
	return 1;	
}


void wmpBCPush(char * data, unsigned short len, char dest, char priority, char protocol, unsigned short offset){
	Msg m;
	memcpy(&m.data[0],data,len);
	m.len=len;
	m.priority=priority;
	m.dest=dest;
	//m.bc.type=protocol;
	m.offset=offset;
	wmpPushBCMsg(&m);	
}

void wmpBCPop(char nqueue, char * data, unsigned short* len, char* source, char* priority, char* protocol){
	Msg m;
	wmpPopBCMsg(&m);
	memcpy(data,&m.data[0],m.len);
	if (len!=NULL){
		*len=m.len;	
	}
	if (source!=NULL){
		*source=m.src;
	}
	if (priority!=NULL){
		*priority=m.priority;
	}
	if (protocol!=NULL){
		*priority=m.priority;
	}
}




